package com.example.jason.aicompetition.application;

import android.app.Application;
import android.content.Context;
import android.media.MediaPlayer;
import android.os.Environment;
import android.util.Log;
import android.widget.Toast;

import com.baidu.aip.imageclassify.AipImageClassify;

import com.iflytek.cloud.SpeechConstant;
import com.iflytek.cloud.SpeechUtility;


public class SpeechApp extends Application {
    public static final String TAG = "SpeechApp";
    private static  Toast mToast;
	private static  Context mContext;

	public static MediaPlayer mp = new MediaPlayer();
	public static String mp3url= "";

	//c1 c2 f1 p1 p2
	public final static String IMAGE_URL = Environment.getExternalStorageDirectory().getAbsolutePath() + "/DCIM/Camera/tempPicture.jpg";

	//baidu API client
	public static AipImageClassify mClient;
	//设置APPID/AK/SK(baidu API)，此处应该填写自己百度云信息
	public static final String APP_ID = "APP_ID";
	public static final String API_KEY = "API_KEY";
	public static final String SECRET_KEY = "SECRET_KEY";

	//讯飞APP_ID 此处应该填写自己讯飞信息，如果使用自己的APP_ID，那么请云平台下载相应的SDK包
	public static final String XUNFEI_APP_ID = "XUNFEI_APP_ID";

	@Override
	public void onCreate() {
		// 应用程序入口处调用,避免手机内存过小,杀死后台进程后通过历史intent进入Activity造成SpeechUtility对象为null
		// 注意：此接口在非主进程调用会返回null对象，如需在非主进程使用语音功能，请增加参数：SpeechConstant.FORCE_LOGIN+"=true"
		// 参数间使用“,”分隔。
		// 设置你申请的应用appid
		
		// 注意： appid 必须和下载的SDK保持一致，否则会出现10407错误
		
		StringBuffer param = new StringBuffer();

		param.append("appid=" + XUNFEI_APP_ID);
		param.append(",");
		// 设置使用v5+
		param.append(SpeechConstant.ENGINE_MODE+"="+SpeechConstant.MODE_MSC);
		SpeechUtility.createUtility(SpeechApp.this, param.toString());
		super.onCreate();
		mContext = getApplicationContext();
        mToast = Toast.makeText(mContext, "", Toast.LENGTH_SHORT);

        //initial baidu API client
		initClient();

		Log.i(TAG, "the service start in speechApp");

	}



	public static Context getmContext(){
		return mContext;
	}

    public static void showTip(final String str) {
        mToast.setText(str);
        mToast.show();
    }

	public static void playMusic() {
		if(mp3url != null) {
			initMediaPlayer();
			mp.start();
		}
	}

	public static void initMediaPlayer() {

		//File file = new File(Environment.getExternalStorageDirectory(), "music.mp3");
		try {
			//MediaPlayer mp = MediaPlayer.create(this, R.raw.music1);
			mp.setDataSource(mp3url);
			mp.prepare();

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public static boolean isPlayingMusic(){
		return mp.isPlaying();
	}

	//baidu cloud API
	private static void initClient() {
		// 初始化一个AipImageClassifyClient
		mClient = new AipImageClassify(APP_ID, API_KEY, SECRET_KEY);

		// 可选：设置网络连接参数
		mClient.setConnectionTimeoutInMillis(2000);
		mClient.setSocketTimeoutInMillis(60000);

	}
}
