package com.example.jason.aicompetition.services;

import android.app.Service;
import android.content.Intent;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.support.annotation.Nullable;
import android.util.Log;


import com.example.jason.aicompetition.MainActivity;
import com.example.jason.aicompetition.application.SpeechApp;
import com.example.jason.aicompetition.util.MySpeechUnderstander;
import com.example.jason.aicompetition.util.TTS;
import com.example.jason.aicompetition.util.Waker;

import com.iflytek.cloud.SpeechError;

import com.iflytek.cloud.SpeechUnderstanderListener;

import com.iflytek.cloud.SynthesizerListener;
import com.iflytek.cloud.UnderstanderResult;
import com.iflytek.cloud.VoiceWakeuper;
import com.iflytek.cloud.WakeuperListener;
import com.iflytek.cloud.WakeuperResult;
import com.example.jason.aicompetition.util.HandleResult;

import static com.example.jason.aicompetition.MainActivity.MSG_FACE_1;
import static com.example.jason.aicompetition.MainActivity.MSG_FACE_2;


/**
 * Created by jason on 17-7-16.
 */

public class SpeechServices extends Service {
    private final String TAG = "SpeechServices";
    private final String WELCOME = "你好，我是小憨，请问有什么可以帮到你的";
    private final String NO_ANSWER = "这个问题，我还需要学习哦";
    private static Handler mHandler;
    private int count = 0;
    private Message mMessage;


    // Waker
    private Waker mWaker;

    // TTS
    private TTS mTts;

    // Understander
    private MySpeechUnderstander mSpeechUnderstander;


    //private boolean isPlaying, isRecording;
    private String mAnswerText;


    private SynthesizerListener mTtsListener = new SynthesizerListener() {

        @Override
        public void onSpeakBegin() {

            //isPlaying = true;
        }

        @Override
        public void onSpeakPaused() {

        }

        @Override
        public void onSpeakResumed() {

        }

        @Override
        public void onBufferProgress(int percent, int beginPos, int endPos, String info) {

        }

        @Override
        public void onSpeakProgress(int percent, int beginPos, int endPos) {
            mMessage = mHandler.obtainMessage(count);
            switch (count) {
                case 2:
                case 3:
                    count++;
                    break;
                case 4:
                    count = 2;
                    break;
            }
            mHandler.sendMessage(mMessage);
        }

        @Override
        public void onCompleted(SpeechError error) {
            if (error == null) {
                Log.i(TAG, "speak onCompleted start");
                mWaker.stopListenimg();
                if ("music".equals(HandleResult.service)) {
                    HandleResult.service = "";
                    SpeechApp.playMusic();
                    SpeechApp.mp.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
                        @Override
                        public void onCompletion(MediaPlayer mediaPlayer) {
                            mSpeechUnderstander.startUnderStanding(speechUnderstandListener);
                        }
                    });
                }
                mSpeechUnderstander.startUnderStanding(speechUnderstandListener);
                if(mHandler == null){
                    Log.w(TAG, "onCompleted: mHandler is null");
                }
                mMessage = mHandler.obtainMessage(MSG_FACE_2);
                mHandler.sendMessage(mMessage);

            } else {
                SpeechApp.showTip(error.getPlainDescription(true));
            }
            Log.i(TAG, "speak onCompleted end");
        }

        @Override
        public void onEvent(int eventType, int arg1, int arg2, Bundle obj) {
            // 以下代码用于获取与云端的会话id，当业务出错时将会话id提供给技术支持人员，可用于查询会话日志，定位出错原因
            // 若使用本地能力，会话id为null
            // if (SpeechEvent.EVENT_SESSION_ID == eventType) {
            // String sid = obj.getString(SpeechEvent.KEY_EVENT_SESSION_ID);
            // Log.d(TAG, "session id =" + sid);
            // }
        }
    };

    private WakeuperListener mWakeuperListener = new WakeuperListener() {

        @Override
        public void onResult(WakeuperResult result) {
            Log.e(TAG, "onResult");
            VoiceWakeuper mIvw = VoiceWakeuper.getWakeuper();
            if (mIvw != null) {
                mIvw.destroy();
            }
            mTts.startSpeaking(mAnswerText, mTtsListener);
            //VoiceWakeuper mIvw = VoiceWakeuper.getWakeuper();
            //mIvw.stopListening();
        }

        @Override
        public void onError(SpeechError error) {
            SpeechApp.showTip(error.getPlainDescription(true));
        }

        @Override
        public void onBeginOfSpeech() {
        }

        @Override
        public void onEvent(int eventType, int isLast, int arg2, Bundle obj) {

        }

        @Override
        public void onVolumeChanged(int volume) {
            SpeechApp.showTip("当前正在说话，音量大小：" + volume);
            //Log.d(TAG, "返回音频数据：" + volume);
        }
    };// end of wakeruperListener

    private SpeechUnderstanderListener speechUnderstandListener = new SpeechUnderstanderListener() {

        @Override
        public void onResult(final UnderstanderResult result) {

            if (result != null && result.getResultString() != null) {
                Log.e(TAG, "result:" + result.getResultString());
                mAnswerText = HandleResult.handleResult(result.getResultString());
                Log.e(TAG, "aaa" + mAnswerText);
                if (mAnswerText == null && !SpeechApp.isPlayingMusic()) {
                    mAnswerText = NO_ANSWER;
                }
                Log.e(TAG, "bbb" + mAnswerText);
                if (mAnswerText != null) {
                    mTts.startSpeaking(mAnswerText, mTtsListener);
                    Log.e(TAG, "ccc" + mAnswerText);
                } else {
                    Log.e(TAG, "speak");
                    mSpeechUnderstander.startUnderStanding(speechUnderstandListener);
                }

            } else {
                if (!SpeechApp.isPlayingMusic()) {
                    mAnswerText = NO_ANSWER;
                    mTts.startSpeaking(mAnswerText, mTtsListener);
                }
            }

        }

        @Override
        public void onVolumeChanged(int volume, byte[] data) {
            SpeechApp.showTip("当前正在说话，音量大小：" + volume);
            //Log.d(TAG, data.length + "");
        }

        @Override
        public void onEndOfSpeech() {
            // 此回调表示：检测到了语音的尾端点，已经进入识别过程，不再接受语音输入
            //isRecording = false;
            /**
             * @TODO MAKE THE BUTTON INVISIBLE
             */

            SpeechApp.showTip("结束说话");
        }

        @Override
        public void onBeginOfSpeech() {
            // 此回调表示：sdk内部录音机已经准备好了，用户可以开始语音输入
            //isRecording = true;
            SpeechApp.showTip("开始说话");
        }

        @Override
        public void onError(SpeechError error) {
            mTts.stopSpeaking();
            mAnswerText = WELCOME;
            mWaker.startListening(mWakeuperListener);
            mMessage = mHandler.obtainMessage(MSG_FACE_1);
            mHandler.sendMessage(mMessage);
        }

        @Override
        public void onEvent(int eventType, int arg1, int arg2, Bundle obj) {
            // 以下代码用于获取与云端的会话id，当业务出错时将会话id提供给技术支持人员，可用于查询会话日志，定位出错原因
            // if (SpeechEvent.EVENT_SESSION_ID == eventType) {
            // String sid = obj.getString(SpeechEvent.KEY_EVENT_SESSION_ID);
            // Log.d(TAG, "session id =" + sid);
            // }
        }
    };

    public void startSpeaking(String speechText){
        if (mTts == null || mTtsListener == null){
            Log.e(TAG, "startSpeeking: mTts == null || mTtsListener == null");
        }
        else if (!SpeechApp.isPlayingMusic()) {
            Log.i(TAG, "startSpeaking: " + speechText);
            mTts.startSpeaking(speechText, mTtsListener);
        }
    }

    @Nullable
    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }


    @Override
    public void onCreate() {
        super.onCreate();

        Log.d(TAG, "Begin");
        //初始化唤醒对象
        mWaker = new Waker();
        mWaker.startListening(mWakeuperListener);
        // 初始化合成对象
        mTts = new TTS();
        // 初始化语音语义理解对象
        mSpeechUnderstander = new MySpeechUnderstander();

        mAnswerText = WELCOME;
        count = 2;
        MainActivity.registerService(this);

    }

    public static void setHandler(Handler handler){
        mHandler = handler;
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId){
        return super.onStartCommand(intent, flags, startId);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();

        mWaker.destory();
        mTts.destory();
        mSpeechUnderstander.destory();

        MainActivity.unRegisterService();
    }
}
