package com.example.jason.aicompetition.util;

import android.util.Log;

import java.util.ArrayList;

import static com.example.jason.aicompetition.application.SpeechApp.TAG;

public class DetectedObject {
    private String name;
    private String nameCn;
    private int id;
    private float probability;
    //相对位置
    private float left;
    private float top;
    private float right;
    private float bottom;

    private static final String LEFT = "左方";
    private static final String RIGHT = "右方";
    private static final String TOP = "上方";
    private static final String BOTTOM = "下方";

    public DetectedObject(String name, String nameCn, int id, float probability,
                          float left,float top,float right,float bottom){
        this.name = name;
        this.nameCn = nameCn;
        this.id = id;
        this.probability = probability;
        this.top = top;
        this.left = left;
        this.right = right;
        this.bottom = bottom;
    }

    public String getName() {
        return name;
    }

    public String getNameCn() {
        return nameCn;
    }

    public float getProbability() {
        return probability;
    }

    public float getLeft() {
        return left;
    }

    public float getTop() {
        return top;
    }

    public float getRight() {
        return right;
    }

    public float getBottom() {
        return bottom;
    }

    public float getCenterX(){
        return (right - left) / 2;
    }

    public float getCenterY(){
        return (bottom - top) / 2;
    }

    public String localization(DetectedObject reference){
        if (reference == null){
            Log.w(TAG, "localization: reference is null");
            return null;
        }
        StringBuilder sb = new StringBuilder();
        String loca;
        //在左
        if (getCenterX() < reference.getCenterX()){
            if (Math.abs(getCenterY() - reference.getCenterY())
                    > Math.abs(getCenterX() - reference.getCenterX())){
                if (getCenterY() < reference.getCenterY()){
                    loca = BOTTOM;
                }
                else {
                    loca = TOP;
                }
            }
            else {
                loca = LEFT;
            }
        }
        //在右
        else {
            if (Math.abs(getCenterY() - reference.getCenterY())
                    > Math.abs(getCenterX() - reference.getCenterX())){
                if (getCenterY() < reference.getCenterY()){
                    loca = BOTTOM;
                }
                else {
                    loca = TOP;
                }
            }
            else {
                loca = RIGHT;
            }
        }
        //谁
        sb.append(getNameCn());
        //在
        sb.append("在");
        //参考系
        sb.append(reference.getNameCn());
        //的
        sb.append("的");
        //方向
        sb.append(loca);
        //end
        sb.append("。");
        return sb.toString();
    }

    public String localization(ArrayList<DetectedObject> list){
        if (list == null || list.isEmpty()){
            Log.w(TAG, "localization: DetectedObject list is null");
            return "我只到看到一个" + getNameCn();
        }
        //获取最大概率物体
        DetectedObject maxProObj = list.get(0);
        for(DetectedObject obj : list){
            if (obj.getProbability() > maxProObj.getProbability()){
                maxProObj = obj;
            }
        }
        return localization(maxProObj);
    }
}
