package com.example.jason.aicompetition.util;

import android.os.Environment;
import android.util.Log;

import com.example.jason.aicompetition.application.SpeechApp;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.File;
import java.util.HashMap;

import static com.example.jason.aicompetition.application.SpeechApp.mClient;


/**
 * Created by jason on 17-7-16.
 */

public class  HandleResult {
    //服务类型
    public static final int WEATHER = 1;
    public static final int OPENQA = 2;
    public static final int FQA = 3;
    public static final int BAIKE = 4;
    public static final int CHAT = 5;
    public static final int DATETIME = 6;
    public static final int OTHER = 7;
    public static final int MUSIC = 8;
    public static final int ANSWER = 9;

    public static String service = "";

    public static int whatService(String response) {
        try {
            JSONObject pSub = new JSONObject(response);
            String operation = pSub.getString("operation");
            String service = pSub.getString("service");
            if (operation.equals("QUERY")) {
                if (service.equals("weather")) {
                    return WEATHER;
                } else {
                    return OTHER;
                }
            } else if (operation.equals("ANSWER")) {
                return ANSWER;
            } else if (operation.equals("PLAY")) {
                if (service.equals("music")) {
                    return MUSIC;
                } else {
                    return OTHER;
                }
            } else {
                return OTHER;
            }
        } catch (JSONException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return -1;
        }
    }

    public static String parseWeather(String pMsg, String result, String text) {
        if (pMsg == null) {
            return null;
        }
        try {
            JSONObject weather = new JSONObject(pMsg);
            StringBuffer sb = new StringBuffer();
            if (weather == null) {
                Log.e(SpeechApp.TAG, "WEATHER IS NULL");
                return null;
            } else {
                JSONObject semantic = weather.getJSONObject("semantic");
                if (semantic == null) {
                    Log.e(SpeechApp.TAG, "semantic is null");
                    return null;
                } else {
                    String date;
                    JSONObject slots = semantic.getJSONObject("slots");
                    if (slots == null) {
                        Log.e(SpeechApp.TAG, "slots is null");
                        return null;
                    } else {
                        JSONObject datetime = slots.getJSONObject("datetime");// 获得询问的日期
                        if (datetime == null) {
                            Log.e(SpeechApp.TAG, "datetime is null");
                            return null;
                        } else {
                            date = datetime.getString("date");
                            sb.append(datetime.getString("dateOrig"));// 获得询问的时间（今天，明天，后天。。）
                        }
                        JSONObject location = slots.getJSONObject("location");
                        if (location == null) {
                            Log.e(SpeechApp.TAG, "slots is null");
                            return null;
                        } else {
                            String addr = location.getString("city");
                            // 判断是不是问的“今天天气怎样？”如果是，重新询问
                            // TODO 日后加入GPS，直接定位到当前城市重新发送查询
                            if (addr.equals("CURRENT_CITY")) {
                                text = weather.getString("text");
                                /**
                                 * @TODO PLAY ANIMATION
                                 */
                                text = weather.getString("text");
                                return "咱们中国地方可大可大了，您问的是哪个位置的天气呀？";
                            }
                            sb.append(location.getString("cityAddr"));// 询问的城市
                            sb.append("的天气");
                            JSONObject data = weather.getJSONObject("data");
                            JSONArray resultArray = data.getJSONArray("result");
                            for (int i = 0; i < resultArray.length(); i++) {
                                JSONObject resultItem = resultArray.getJSONObject(i);
                                String itemDate = resultItem.getString("date");
                                if (itemDate.equals(date)) {
                                    sb.append(resultItem.getString("weather"));
                                    sb.append("，");
                                    sb.append(resultItem.getString("tempRange"));
                                    sb.append("，");
                                    sb.append(resultItem.getString("wind"));
                                    sb.append("。");
                                    break;
                                }
                            }
                            result = sb.toString();//机器人的回答
                            return result;//机器人的回答
                        }
                    }
                }
            }
        } catch (JSONException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return null;
    }

    public static String parseMusic(String pMsg) {
        if (pMsg == null) {
            return null;
        }

        try {
            JSONObject musicJson = new JSONObject(pMsg);
            JSONObject semantic = musicJson.getJSONObject("semantic");
            if (semantic == null) {

                JSONObject data = musicJson.getJSONObject("data");
                JSONArray result = data.getJSONArray("result");
                JSONObject resultJson = result.getJSONObject(0);
                return resultJson.getString("downloadUrl");
            }
            //JSONObject slots=semantic.getJSONObject("slots");
            JSONObject slots = semantic.optJSONObject("slots");
            if (slots == null) {
                Log.e(SpeechApp.TAG, "22");
                JSONObject data = musicJson.getJSONObject("data");
                JSONArray result = data.getJSONArray("result");
                JSONObject resultJson = result.getJSONObject(0);
                return resultJson.getString("downloadUrl");
            } else if (slots.getString("artist") == null && slots.getString("song") != null) {
                return null;
            } else {

                JSONObject data = musicJson.getJSONObject("data");
                JSONArray result = data.getJSONArray("result");
                JSONObject resultJson = result.getJSONObject(0);
                Log.e(SpeechApp.TAG, resultJson.getString("downloadUrl"));
                return resultJson.getString("downloadUrl");
            }


        } catch (JSONException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();

            return null;
        }

    }

    public static String handleResult(String jasonResult) {
        Log.d(SpeechApp.TAG, jasonResult);
        service = null;
        String text = null;
        boolean haveBottle = false;
        try {
            JSONObject re = new JSONObject(jasonResult);
            //如果有回复，问题是：杯子在哪里
            if (re.has("answer")) {
                JSONObject ans = re.getJSONObject("answer");
                if (ans.has("question")) {
                    JSONObject question = ans.getJSONObject("question");
                    if (question.has("question_ws")) {
                        String qws = question.getString("question_ws");
                        //分词
                        String[] temp = qws.split("  ");
                        //temp 包含 “杯子” “在” “哪里”
                        for (String t : temp) {
                            t = t.split("/")[0];
                            Log.i(SpeechApp.TAG, "handleResult: " + t);
                            //判断是否有“杯子”
                            if ("杯子".equals(t) || "水杯".equals(t)){
                                haveBottle = true;
                            }
                        }
                        //拍照，得到结果

//                        new Thread(new Runnable() {
//                            @Override
//                            public void run() {
//                                File file = new File(SpeechApp.IMAGE_URL);
////                                File filetemp = new File(Environment.getExternalStorageDirectory().getAbsoluteFile() + "/DCIM/Camera");
////                                File [] fs = filetemp.listFiles();
////                                for (File f : fs){
////                                    Log.i(SpeechApp.TAG, "all path :" + f.getPath());
////                                }
////                                Log.i(SpeechApp.TAG, "imageUrl path :" + SpeechApp.IMAGE_URL);
//
//                                File[] files = null;
//                                String imageUrl = null;
//                                if (file.exists()) {
//                                    files = file.listFiles();
//                                    Log.i(SpeechApp.TAG, "imageUrl path :" + file.getPath());
//                                } else {
//                                    Log.i(SpeechApp.TAG, "file path is null");
//                                }
//                                if (files != null) {
//                                    imageUrl = files[0].getPath();
//                                    Log.i(SpeechApp.TAG, "imageUrl path :" + imageUrl);
//                                } else {
//                                    Log.i(SpeechApp.TAG, "files path is null");
//                                }
//
//                                imageUrl = Environment.getExternalStorageDirectory().getAbsolutePath() + "/Downloads/timg(1).jpg";
//                                // 调用接口
//                                JSONObject res = mClient.advancedGeneral(imageUrl, new HashMap<String, String>());
//                                //System.out.println(res.toString(2));
//                                if (res != null) {
//                                    try {
//                                        Log.i(SpeechApp.TAG, "exec: " + res.toString(2));
//                                        //返回数据
////                                        Message message = mHandler.obtainMessage();
////                                        Bundle bundle = new Bundle();
////                                        bundle.putString(OBJECT_KEY, res.toString());
////                                        message.setData(bundle);
////                                        mHandler.sendMessage(message);
//
//                                    } catch (Exception e) {
//
//                                    } finally {
//
//                                    }
//                                }
//                            }
//                        }).start();
                    }
                }
                Log.d(SpeechApp.TAG, "handleResult: " + ans);

                if(haveBottle) {
                    //启动相机拍摄
                    PhotoManager.getInstance().takePicture();
                    Log.d(SpeechApp.TAG, "haveBottle is true and takePicture");
                }
            }

            //下面服务种类判断
            if (re.has("service")) {
                service = re.getString("service");
                if (service.equals("weather")) {
                    return re.getJSONObject("answer").getString("text");
                } else if (service.equals("musicX")) {
                    return re.getJSONObject("answer").getString("text");
                } else if (service.equals("openQA")) {
                    if (re.getString("operation") != null && re.getString("operation").equals("ANSWER")) {
                        String cmd = re.getString("text");
                        text = re.getJSONObject("answer").getString("text");

                        if (cmd.equals("小憨。")) {
                            if (SpeechApp.isPlayingMusic()) {
                                SpeechApp.mp.stop();
                                SpeechApp.mp.release();
                            }
                        }

                        return text;
                    }
                } else if (service.equals("joke")) {
                    Log.e("adsad", "joke");
                    service = "music";
                    JSONObject obj = (JSONObject) re.getJSONObject("data").getJSONArray("result").get(0);
                    SpeechApp.mp3url = obj.getString("mp3Url");
                    return re.getJSONObject("answer").getString("text");
                } else if (service.equals("news")) {
                    Log.e("adsad33333", "news");
                    service = "music";
                    JSONObject obj = (JSONObject) re.getJSONObject("data").getJSONArray("result").get(0);
                    SpeechApp.mp3url = obj.getString("url");
                    return re.getJSONObject("answer").getString("text");
                } else if (service.equals("cookbook")) {
                    JSONObject obj = (JSONObject) re.getJSONObject("data").getJSONArray("result").get(0);
                    return obj.getString("steps");
                } else if (service.equals("story")) {
                    service = "music";
                    JSONObject obj = (JSONObject) re.getJSONObject("data").getJSONArray("result").get(0);
                    SpeechApp.mp3url = obj.getString("playUrl");
                    return re.getJSONObject("answer").getString("text");
                } else {
                    return re.getJSONObject("answer").getString("text");
                }

            } else {
                if (re.has("semantic")) {
                    return re.getJSONObject("semantic").getJSONObject("answer").getString("text");
                }
                return null;
            }

        } catch (JSONException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return null;
        }
        return null;
    }

}
