package com.example.jason.aicompetition.util;

import android.content.Context;
import android.util.Log;

import com.example.jason.aicompetition.application.SpeechApp;
import com.iflytek.cloud.SpeechConstant;
import com.iflytek.cloud.VoiceWakeuper;
import com.iflytek.cloud.WakeuperListener;
import com.iflytek.cloud.util.ResourceUtil;
import com.example.jason.aicompetition.R;

/**
 * Created by jason on 17-7-16.
 */

public class Waker {
    private final String TAG = "Waker";
    private  int curThresh = 10;
    private  String keep_alive = "1";
    private  String ivwNetMode = "0";
    private VoiceWakeuper mIvw;
    private Context context;
    private boolean isListening = false;

    public Waker(){
        context = SpeechApp.getmContext();
        mIvw = VoiceWakeuper.getWakeuper();
        if(mIvw == null) {
            mIvw = VoiceWakeuper.createWakeuper(context, null);
        }
        if (mIvw == null){
            Log.w(TAG, "Waker: mIvw == null1");
        }
    }

    public boolean isNull(){
        return mIvw == null;
    }


    public void startListening(WakeuperListener mWakeuperListener){
        if (mIvw != null) {
            SpeechApp.showTip("唤醒开始");
            setParamWake();
            // 启动唤醒
            mIvw.startListening(mWakeuperListener);
            isListening = true;
        } else {
            SpeechApp.showTip("唤醒未初始化");
        }
    }
    public boolean isListening(){
        return isListening;
    }

    public void stopListenimg(){
        isListening = false;
        if (mIvw != null) {
            mIvw.stopListening();
        }
        else {
            Log.w(TAG, "stopListenimg: mIvw is null");
        }
    }
    public void setParamWake() {
        Log.e(SpeechApp.TAG, "start paramwake");
        // 清空参数.
        mIvw.setParameter(SpeechConstant.PARAMS, null);
        // 唤醒门限值，根据资源携带的唤醒词个数按照“id:门限;id:门限”的格式传入
        mIvw.setParameter(SpeechConstant.IVW_THRESHOLD, "0:" + curThresh);
        // 设置唤醒模式
        mIvw.setParameter(SpeechConstant.IVW_SST, "wakeup");
        // 设置持续进行唤醒
        mIvw.setParameter(SpeechConstant.KEEP_ALIVE, keep_alive);
        // 设置闭环优化网络模式
        mIvw.setParameter(SpeechConstant.IVW_NET_MODE, ivwNetMode);
        // 设置唤醒资源路径
        mIvw.setParameter(SpeechConstant.IVW_RES_PATH, getResource());
    }

    public void destory(){
        mIvw = VoiceWakeuper.getWakeuper();
        if (mIvw != null) {
            mIvw.destroy();
        }
    }

    public  String getResource() {
        final String resPath = ResourceUtil.generateResourcePath(context,ResourceUtil.RESOURCE_TYPE.assets, "ivw/"+context.getString(R.string.app_id)+".jet");
        Log.d(SpeechApp.TAG, "resPath: "+resPath );
        return resPath;
    }

}
